### Client side module

import urllib
#import urllib2
import httplib
import socket
import sys

import client
from things import *

server_prefix = 'http://localhost:8675'

def check_hostname(hostname):
    try:
        s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        s.connect((hostname, 8675))
        s.close()
    except socket.error, a:
        return str(a)
    return False

def set_hostname(hostname):
    error = check_hostname(hostname)
    if error:
        return error
    else:
        global server_prefix, http_handle
        server_prefix = 'http://%s:8675'%hostname
        http_handle = httplib.HTTPConnection( hostname, 8675 )
        return False


def make_connection( url ):
#	http_handle.set_debuglevel(1)
	http_handle.putrequest('GET', url)
	http_handle.putheader('Accept', 'text/html')
	http_handle.putheader('Accept', 'text/plain')
	http_handle.putheader('Connection', 'keep-alive')  # XXX
	http_handle.endheaders()
	resp = http_handle.getresponse()
	return resp

def read_result( resp ):
	data = resp.read() 
	return data

def get_dm():
	resp = make_connection( '/dm.spy' )
	return eval( read_result( resp ) )
 
def get_pc(type):
	resp = make_connection( '/pc.spy?type=%s' % (type))
	return eval( read_result( resp ) )

def get_grid():
	resp = make_connection( '/grid.spy' )
	return eval( read_result( resp ) )

def get_state():
    resp = make_connection( '/state.spy' )
    lines = read_result( resp )
#    print "get state: lines are", lines
    things, chatlines, who_won = eval(lines)
    positions = {}
    for key, value in things.items():
        positions[value.position] = value
    return things, chatlines, positions, who_won

def move(pid, delta_x, delta_y):
	resp = make_connection( '/move.spy?pid=%s&x=%d&y=%d' % (pid, delta_x, delta_y) )
	lines = read_result( resp )

def command_monster(pid, rect):
	resp = make_connection( '/command.spy?pid=%s&x=%s&y=%s&w=%s&h=%s' % (pid, rect.x, rect.y, rect.w, rect.h))
	lines = read_result( resp )

def chat(pid,chatmsg):
	resp = make_connection( '/chat.spy?pid=%d&chatmsg=%s' % (pid, urllib.quote(chatmsg)))
	lines = read_result( resp )

def fight(pid):
	resp = make_connection( '/fight.spy?pid=%s' % pid )
	return eval(read_result( resp ))

def heal(pid):
    resp = make_connection('/heal.spy?pid=%s' % pid)
    read_result(resp)

def fire(pid):
    resp = make_connection('/fire.spy?pid=%s' % pid)
    return eval(read_result(resp))
