
class Foo:
    def __init__( self ):
        self.tiles = []
        for x in range(66):
            self.tiles.append( Tile(x) )

    def Tile(self, num):
        return self.tiles[num]

class Tile:

    def __init__(self,id):
        self.id = id

    def __repr__(self):
        if self.id < 50: return ' '
        elif ( self.id == 50 ): return '+'
        elif ( self.id == 51 ): return 'X'
        elif ( self.id == 55 ): return 'r'
        elif ( self.id == 56 ): return '7'
        elif ( self.id == 57 ): return '-'
        elif ( self.id == 59 ): return 'L'
        elif ( self.id == 60 ): return 'J'
        elif ( self.id == 61 ): return '-'
        elif ( self.id == 62 ): return '|'
        elif ( self.id == 63 ): return '|'
        elif ( self.id == 64 ): return '%'
        elif ( self.id == 65 ): return '%'
        else:
            return '#'

    # a more compact representation for making a text representation of the map
    def __str__(self):
        if self.id < 50:
            return ' '
        elif ( self.id == 50 ): return '+'
        elif ( self.id == 51 ): return 'X'
        elif ( self.id == 55 ): return 'r'
        elif ( self.id == 56 ): return '7'
        elif ( self.id == 57 ): return '-'
        elif ( self.id == 59 ): return 'L'
        elif ( self.id == 60 ): return 'J'
        elif ( self.id == 61 ): return '-'
        elif ( self.id == 62 ): return '|'
        elif ( self.id == 63 ): return '|'
        elif ( self.id == 64 ): return '%'
        elif ( self.id == 65 ): return '%'
        else:
            return '#'

class Thing:
    def __init__(self, id, position, type = 'generic'):
        self.id = id
        self.position = position
        self.type = type

    def __repr__(self):
        if self.id < 50: return ' '
        elif ( self.id == 50 ): return '+'
        elif ( self.id == 51 ): return 'X'
        elif ( self.id == 55 ): return 'r'
        elif ( self.id == 56 ): return '7'
        elif ( self.id == 57 ): return '-'
        elif ( self.id == 59 ): return 'L'
        elif ( self.id == 60 ): return 'J'
        elif ( self.id == 61 ): return '-'
        elif ( self.id == 62 ): return '|'
        elif ( self.id == 63 ): return '|'
        elif ( self.id == 64 ): return '%'
        elif ( self.id == 65 ): return '%'
        else:
            return '#'


