### Server side module

import server
import things

def update():
    for player in server.map.players:
        player.maybe_recover_mp()

class Elf(things.Player):

    def __init__(self, id, position, type = 'generic', hp = 25, max_hp = 25, mp = 15, max_mp = 15, bag = None):
        self.type = 'elf'
        things.Player.__init__(self, id, position, type, hp, max_hp, mp, max_mp, bag)
        self.strength = 4
        self.dex = 8
        self.spirit = 3
        self.armor = 0

class Knight(things.Player):

    def __init__(self, id, position, type = 'generic', hp = 30, max_hp = 30, mp = 15, max_mp = 15, bag = None):
        self.type = 'knight'
        things.Player.__init__(self, id, position, type, hp, max_hp, mp, max_mp, bag)
        self.strength = 8
        self.dex = 6
        self.spirit = 1
        self.armor = 0

class Mage(things.Player):

    def __init__(self, id, position, type = 'generic', hp = 20, max_hp = 20, mp = 15, max_mp = 15, bag = None):
        self.type = 'mage'
        things.Player.__init__(self, id, position, type, hp, max_hp, mp, max_mp, bag)
        self.strength = 2
        self.dex = 6
        self.spirit = 7
        self.armor = 0
